﻿

Imports AzureMarketPlace
Namespace AzureMarketPlaceDemo
    Public Class TranslatorController
        Inherits System.Web.Mvc.Controller


        ' GET: /Translator
        Function Index() As ActionResult
            Dim model As New TranslatorModel With {
                .SourceLanguageCode = "en",
                .SourceText = "Sample text to be translated to Spanish",
                .TranslationLanguageCode = "es", .TranslationText = ""
            }
            Return View(model)
        End Function

        ' POST: /Translator/Translation
        <HttpPost()>
        Function Translation(model As TranslatorModel) As ActionResult
            Dim ErrorObject As Exception = New Exception("")
            Try
                Dim context As New Helpers.Microsoft.TranslatorContainer(AzureMarketPlace.Helpers.ServiceUri.Translator)
                context.Credentials = (New AzureMarketPlace.Helpers.MarketplaceCredentials).GetCredentials
                Dim translated = context.Translate(model.SourceText, model.TranslationLanguageCode, model.SourceLanguageCode).ToList()
                If (Not IsNothing(translated) AndAlso translated.Count > 0) Then
                    model.TranslationText = translated(0).Text
                    Return View(model)
                End If
            Catch ex As Exception
                ErrorObject = ex
            End Try
            Return RedirectToAction("Index", "Home", New With {.Error = ErrorObject})
        End Function

    End Class
End Namespace
