﻿Imports AzureMarketPlace.Helpers

Namespace AzureMarketPlaceDemo
    Public Class ZillowController
        Inherits System.Web.Mvc.Controller

        ' GET: /Zillow/Valuation
        <HttpGet()>
        Function Valuation() As ActionResult
            Dim context As New Zillow.HomeValuationApiContainer(ServiceUri.ZillowHomeValuation)
            context.Credentials = (New MarketplaceCredentials).GetCredentials
            'Get 10 comparables for 1600 Pennsylvania Ave NW, Washington, DC 20006
            'Zillow property ID was obtained from the URL after looking up the property by address on zillow.com web site
            Dim model = context.GetComparables(88165477, 10).ToList
            Return View(model)
        End Function

        ' GET: /Zillow/Mortgage
        <HttpGet()>
        Function Mortgage() As ActionResult
            Dim context As New Zillow.MortgageInformationApiContainer(ServiceUri.ZillowMortgateInformation)
            context.Credentials = (New MarketplaceCredentials).GetCredentials
            Dim model = context.GetRateSummary("MI").ToList()
            Return View(model)
        End Function

        ' GET: /Zillow/Neighborhood
        <HttpGet()>
        Function Neighborhood() As ActionResult
            Dim context As New Zillow.NeighborhoodDataApiContainer(ServiceUri.ZillowNeighborhoodData)
            context.Credentials = (New MarketplaceCredentials).GetCredentials
            Dim model = context.GetDemographicsByZipCode("48235").ToList()
            Return View(model)
        End Function

        ' GET: /Zillow/Property
        <HttpGet()>
        Function PropertyDetail() As ActionResult
            Dim context As New Zillow.PropertyDetailsApiContainer(ServiceUri.ZillowPropertyDetails)
            context.Credentials = (New MarketplaceCredentials).GetCredentials
            Dim model = context.GetUpdatedPropertyDetails(84074482).ToList()
            Return View(model(0))
        End Function

    End Class
End Namespace
