﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using Microsoft.Win32;

namespace AzureMarketPlace.Helpers
{
    public class MarketPlaceCredentials
    {
        public virtual NetworkCredential GetCredentials() {
            var customerID = GetCustomerID();
            var accessKey = GetAccountKey();
            NetworkCredential result = new NetworkCredential(customerID, accessKey);
            return result;

        }

        public string test() { return ""; }

        //HKEY_LOCAL_MACHINE\Software\VSM\ON VB\AzureMarketplace\CustomerID
        private string GetCustomerID()
        {
            string regPath = @"SOFTWARE\VSM\ON VB\AzureMarketplace";
            var regKey = Registry.LocalMachine.OpenSubKey(regPath);
            var valCustomerID = regKey.GetValue("CustomerID").ToString();
            return valCustomerID;
        }

        //HKEY_LOCAL_MACHINE\Software\VSM\ON VB\AzureMarketplace\AccessKey
        private string GetAccountKey()
        {
            string regPath = @"SOFTWARE\VSM\ON VB\AzureMarketplace";
            var regKey = Registry.LocalMachine.OpenSubKey(regPath);
            var valAccessKey = regKey.GetValue("AccountKey").ToString();
            return valAccessKey;
        }
    }




}
