﻿Imports System.Data.Services.Client

Namespace Helpers.Zillow
    Public Class MortgageInformationApiContainer
        Inherits DataServiceContext
        ' Methods
        Public Sub New(ByVal serviceRoot As Uri)
            MyBase.New(serviceRoot)
        End Sub

        Public Function GetMonthlyPayments(ByVal Price As Double, ByVal DownPaymentPercent As Double?, ByVal DownPaymentDollars As Double?, ByVal ZipCode As String) As DataServiceQuery(Of MonthlyPaymentsEntity)
            Dim query As DataServiceQuery(Of MonthlyPaymentsEntity) = MyBase.CreateQuery(Of MonthlyPaymentsEntity)("GetMonthlyPayments").AddQueryOption("Price", Price)
            If (DownPaymentPercent.HasValue AndAlso DownPaymentPercent.HasValue) Then
                query = query.AddQueryOption("DownPaymentPercent", DownPaymentPercent.Value)
            End If
            If (DownPaymentDollars.HasValue AndAlso DownPaymentDollars.HasValue) Then
                query = query.AddQueryOption("DownPaymentDollars", DownPaymentDollars.Value)
            End If
            If (Not ZipCode Is Nothing) Then
                query = query.AddQueryOption("ZipCode", ("'" & Uri.EscapeDataString(ZipCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetRateSummary(ByVal State As String) As DataServiceQuery(Of RateSummaryEntity)
            Dim query As DataServiceQuery(Of RateSummaryEntity) = MyBase.CreateQuery(Of RateSummaryEntity)("GetRateSummary")
            If (Not State Is Nothing) Then
                query = query.AddQueryOption("State", ("'" & Uri.EscapeDataString(State) & "'"))
            End If
            Return query
        End Function
    End Class

    Public Class MonthlyPaymentsEntity
        Public Sub New()
        End Sub
        Public Property DownPayment As Double?
        Public Property LoanType As String
        Public Property MonthlyHazardInsurance As Double?
        Public Property MonthlyMortgageInsurance As Double?
        Public Property MonthlyPrincipalAndInterest As Double?
        Public Property MonthlyPropertyTaxes As Double?
        Public Property Rate As Double?
    End Class

    Public Class RateSummaryEntity
        Public Sub New()
        End Sub
        Public Property FifteenYearFixedCountLastWeek As Double?
        Public Property FifteenYearFixedCountToday As Double?
        Public Property FifteenYearFixedLastWeek As Double?
        Public Property FifteenYearFixedToday As Double?
        Public Property FiveOneARMCountLastWeek As Double?
        Public Property FiveOneARMCountToday As Double?
        Public Property FiveOneARMLastWeek As Double?
        Public Property FiveOneARMToday As Double?
        Public Property ThirtyYearFixedCountLastWeek As Double?
        Public Property ThirtyYearFixedCountToday As Double?
        Public Property ThirtyYearFixedLastWeek As Double?
        Public Property ThirtyYearFixedToday As Double?
    End Class

End Namespace

