﻿Imports System.Data.Services.Client

Namespace Helpers.Microsoft
    Public Class TranslatorContainer
        Inherits DataServiceContext
        ' Methods
        Public Sub New(ByVal serviceRoot As Uri)
            MyBase.New(serviceRoot)
        End Sub

        Public Function Detect(ByVal [Text] As String) As DataServiceQuery(Of DetectedLanguage)
            If ([Text] Is Nothing) Then
                Throw New ArgumentNullException("Text", "Text value cannot be null")
            End If
            Dim query As DataServiceQuery(Of DetectedLanguage) = MyBase.CreateQuery(Of DetectedLanguage)("Detect")
            If (Not [Text] Is Nothing) Then
                query = query.AddQueryOption("Text", ("'" & Uri.EscapeDataString([Text]) & "'"))
            End If
            Return query
        End Function

        Public Function GetLanguagesForTranslation() As DataServiceQuery(Of Language)
            Return MyBase.CreateQuery(Of Language)("GetLanguagesForTranslation")
        End Function

        Public Function Translate(ByVal [Text] As String, ByVal [To] As String, ByVal From As String) As DataServiceQuery(Of Translation)
            If ([Text] Is Nothing) Then
                Throw New ArgumentNullException("Text", "Text value cannot be null")
            End If
            If ([To] Is Nothing) Then
                Throw New ArgumentNullException("To", "To value cannot be null")
            End If
            Dim query As DataServiceQuery(Of Translation) = MyBase.CreateQuery(Of Translation)("Translate")
            If (Not [Text] Is Nothing) Then
                query = query.AddQueryOption("Text", ("'" & Uri.EscapeDataString([Text]) & "'"))
            End If
            If (Not [To] Is Nothing) Then
                query = query.AddQueryOption("To", ("'" & Uri.EscapeDataString([To]) & "'"))
            End If
            If (Not From Is Nothing) Then
                query = query.AddQueryOption("From", ("'" & Uri.EscapeDataString(From) & "'"))
            End If
            Return query
        End Function

    End Class

    Public Class DetectedLanguage
        Public Sub New()
        End Sub
        Public Property Code As String
    End Class

    Public Class Language
        Public Sub New()

        End Sub
        Public Property Code As String
    End Class

    Public Class Translation
        Public Sub New()
        End Sub
        Public Property [Text] As String
    End Class

End Namespace
