﻿Imports System.Data.Services.Client
Namespace Helpers.WolframAlpha
    Public Class WolframAlphaFactsContainer
        Inherits DataServiceContext
        ' Methods
        Public Sub New(ByVal serviceRoot As Uri)
            MyBase.New(serviceRoot)
        End Sub

        Public Function GetHtmlResults(ByVal Input As String, ByVal Location As String, ByVal LatitudeLongitude As String, ByVal Width As Short?) As DataServiceQuery(Of HtmlPodEntity)
            If (Input Is Nothing) Then
                Throw New ArgumentNullException("Input", "Input value cannot be null")
            End If
            Dim query As DataServiceQuery(Of HtmlPodEntity) = MyBase.CreateQuery(Of HtmlPodEntity)("GetHtmlResults")
            If (Not Input Is Nothing) Then
                query = query.AddQueryOption("Input", ("'" & Uri.EscapeDataString(Input) & "'"))
            End If
            If (Not Location Is Nothing) Then
                query = query.AddQueryOption("Location", ("'" & Uri.EscapeDataString(Location) & "'"))
            End If
            If (Not LatitudeLongitude Is Nothing) Then
                query = query.AddQueryOption("LatitudeLongitude", ("'" & Uri.EscapeDataString(LatitudeLongitude) & "'"))
            End If
            Dim nullable As Short? = Width
            Dim nullable2 As Integer? = If(nullable.HasValue, New Integer?(nullable.GetValueOrDefault), Nothing)
            If (nullable2.HasValue AndAlso Width.HasValue) Then
                query = query.AddQueryOption("Width", Width.Value)
            End If
            Return query
        End Function

        Public Function GetImageResults(ByVal Input As String, ByVal Location As String, ByVal LatitudeLongitude As String, ByVal Width As Short?) As DataServiceQuery(Of DefaultPodEntity)
            If (Input Is Nothing) Then
                Throw New ArgumentNullException("Input", "Input value cannot be null")
            End If
            Dim query As DataServiceQuery(Of DefaultPodEntity) = MyBase.CreateQuery(Of DefaultPodEntity)("GetImageResults")
            If (Not Input Is Nothing) Then
                query = query.AddQueryOption("Input", ("'" & Uri.EscapeDataString(Input) & "'"))
            End If
            If (Not Location Is Nothing) Then
                query = query.AddQueryOption("Location", ("'" & Uri.EscapeDataString(Location) & "'"))
            End If
            If (Not LatitudeLongitude Is Nothing) Then
                query = query.AddQueryOption("LatitudeLongitude", ("'" & Uri.EscapeDataString(LatitudeLongitude) & "'"))
            End If
            Dim nullable As Short? = Width
            Dim nullable2 As Integer? = If(nullable.HasValue, New Integer?(nullable.GetValueOrDefault), Nothing)
            If (nullable2.HasValue AndAlso Width.HasValue) Then
                query = query.AddQueryOption("Width", Width.Value)
            End If
            Return query
        End Function

        Public Function GetPlainTextResults(ByVal Input As String, ByVal Location As String, ByVal LatitudeLongitude As String, ByVal Width As Short?) As DataServiceQuery(Of PlainTextPodEntity)
            If (Input Is Nothing) Then
                Throw New ArgumentNullException("Input", "Input value cannot be null")
            End If
            Dim query As DataServiceQuery(Of PlainTextPodEntity) = MyBase.CreateQuery(Of PlainTextPodEntity)("GetPlainTextResults")
            If (Not Input Is Nothing) Then
                query = query.AddQueryOption("Input", ("'" & Uri.EscapeDataString(Input) & "'"))
            End If
            If (Not Location Is Nothing) Then
                query = query.AddQueryOption("Location", ("'" & Uri.EscapeDataString(Location) & "'"))
            End If
            If (Not LatitudeLongitude Is Nothing) Then
                query = query.AddQueryOption("LatitudeLongitude", ("'" & Uri.EscapeDataString(LatitudeLongitude) & "'"))
            End If
            Dim nullable As Short? = Width
            Dim nullable2 As Integer? = If(nullable.HasValue, New Integer?(nullable.GetValueOrDefault), Nothing)
            If (nullable2.HasValue AndAlso Width.HasValue) Then
                query = query.AddQueryOption("Width", Width.Value)
            End If
            Return query
        End Function
    End Class

    Public Class HtmlPodEntity
        Public Sub New()
        End Sub
        Public Property Css As String
        Public Property Id As String
        Public Property Markup As String
        Public Property Position As Short
        Public Property Scripts As String
        Public Property Title As String
    End Class

    Public Class DefaultPodEntity
        Public Sub New()
        End Sub
        Public Property Img As String
        Public Property ParentId As String
        Public Property ParentPosition As Short
        Public Property ParentTitle As String
        Public Property PlainText As String
        Public Property Title As String
    End Class

    Public Class PlainTextPodEntity
        Public Sub New()
        End Sub
        Public Property ParentId As String
        Public Property ParentPosition As Short
        Public Property ParentTitle As String
        Public Property PlainText As String
        Public Property Title As String
    End Class

End Namespace