﻿Imports System.Data.Services.Client
Namespace Helpers.WorldBank
    Public Class WorldDevelopmentIndicatorsContainer
        Inherits DataServiceContext
        ' Methods
        Public Sub New(ByVal serviceRoot As Uri)
            MyBase.New(serviceRoot)
        End Sub

        Public Function GetCountries(ByVal LanguageCode As String) As DataServiceQuery(Of CountryEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query1 As DataServiceQuery(Of CountryEntity) = MyBase.CreateQuery(Of CountryEntity)("GetCountries")
            If (Not LanguageCode Is Nothing) Then
                query1 = query1.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query1
        End Function

        Public Function GetCountriesByRegion(ByVal LanguageCode As String, ByVal RegionCode As String) As DataServiceQuery(Of CountryEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            If (RegionCode Is Nothing) Then
                Throw New ArgumentNullException("RegionCode", "RegionCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of CountryEntity) = MyBase.CreateQuery(Of CountryEntity)("GetCountriesByRegion")
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            If (Not RegionCode Is Nothing) Then
                query = query.AddQueryOption("RegionCode", ("'" & Uri.EscapeDataString(RegionCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetData(ByVal LanguageCode As String, ByVal CountryCode As String, ByVal IndicatorCode As String) As DataServiceQuery(Of DataEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            If (CountryCode Is Nothing) Then
                Throw New ArgumentNullException("CountryCode", "CountryCode value cannot be null")
            End If
            If (IndicatorCode Is Nothing) Then
                Throw New ArgumentNullException("IndicatorCode", "IndicatorCode value cannot be null")
            End If
            Dim query1 As DataServiceQuery(Of DataEntity) = MyBase.CreateQuery(Of DataEntity)("GetData")
            If (Not LanguageCode Is Nothing) Then
                query1 = query1.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            If (Not CountryCode Is Nothing) Then
                query1 = query1.AddQueryOption("CountryCode", ("'" & Uri.EscapeDataString(CountryCode) & "'"))
            End If
            If (Not IndicatorCode Is Nothing) Then
                query1 = query1.AddQueryOption("IndicatorCode", ("'" & Uri.EscapeDataString(IndicatorCode) & "'"))
            End If
            Return query1
        End Function

        Public Function GetDataSources(ByVal LanguageCode As String) As DataServiceQuery(Of DataSourceEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of DataSourceEntity) = MyBase.CreateQuery(Of DataSourceEntity)("GetDataSources")
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetIncomeLevels(ByVal LanguageCode As String) As DataServiceQuery(Of IncomeLevelEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of IncomeLevelEntity) = MyBase.CreateQuery(Of IncomeLevelEntity)("GetIncomeLevels")
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetIndicators(ByVal LanguageCode As String) As DataServiceQuery(Of IndicatorEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query1 As DataServiceQuery(Of IndicatorEntity) = MyBase.CreateQuery(Of IndicatorEntity)("GetIndicators")
            If (Not LanguageCode Is Nothing) Then
                query1 = query1.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query1
        End Function

        Public Function GetIndicatorsByDataSource(ByVal LanguageCode As String, ByVal DataSourceId As Integer) As DataServiceQuery(Of IndicatorEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of IndicatorEntity) = MyBase.CreateQuery(Of IndicatorEntity)("GetIndicatorsByDataSource").AddQueryOption("DataSourceId", DataSourceId)
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetIndicatorsByTopic(ByVal LanguageCode As String, ByVal TopicId As Integer) As DataServiceQuery(Of IndicatorEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query1 As DataServiceQuery(Of IndicatorEntity) = MyBase.CreateQuery(Of IndicatorEntity)("GetIndicatorsByTopic").AddQueryOption("TopicId", TopicId)
            If (Not LanguageCode Is Nothing) Then
                query1 = query1.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query1
        End Function

        Public Function GetLendingTypes(ByVal LanguageCode As String) As DataServiceQuery(Of LendingTypeEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of LendingTypeEntity) = MyBase.CreateQuery(Of LendingTypeEntity)("GetLendingTypes")
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query
        End Function

        Public Function GetRegions(ByVal LanguageCode As String) As DataServiceQuery(Of RegionEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query1 As DataServiceQuery(Of RegionEntity) = MyBase.CreateQuery(Of RegionEntity)("GetRegions")
            If (Not LanguageCode Is Nothing) Then
                query1 = query1.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query1
        End Function

        Public Function GetTopics(ByVal LanguageCode As String) As DataServiceQuery(Of TopicEntity)
            If (LanguageCode Is Nothing) Then
                Throw New ArgumentNullException("LanguageCode", "LanguageCode value cannot be null")
            End If
            Dim query As DataServiceQuery(Of TopicEntity) = MyBase.CreateQuery(Of TopicEntity)("GetTopics")
            If (Not LanguageCode Is Nothing) Then
                query = query.AddQueryOption("LanguageCode", ("'" & Uri.EscapeDataString(LanguageCode) & "'"))
            End If
            Return query
        End Function
    End Class

    Public Class CountryEntity
        Public Sub New()
        End Sub
        Public Property CapitalCity As String
        Public Property CodeIso2Letter As String
        Public Property CodeIso3Letter As String
        Public Property IncomeLevelId As String
        Public Property IncomeLevelName As String
        Public Property Latitude As Double?
        Public Property LendingTypeCode As String
        Public Property LendingTypeName As String
        Public Property Longitude As Double?
        Public Property Name As String
        Public Property RegionCode As String
        Public Property RegionName As String
    End Class

    Public Class DataEntity
        Public Sub New()
        End Sub
        Public Property CountryCode As String
        Public Property CountryName As String
        Public Property [Date] As String
        Public Property IndicatorCode As String
        Public Property IndicatorName As String
        Public Property Value As String
    End Class

    Public Class DataSourceEntity
        Public Sub New()
        End Sub
        Public Property Description As String
        Public Property Id As Integer
        Public Property Name As String
        Public Property Url As String
    End Class

    Public Class IncomeLevelEntity
        Public Sub New()
        End Sub
        Public Property Id As String
        Public Property Name As String
    End Class

    Public Class IndicatorEntity
        Public Sub New()
        End Sub
        Public Property Code As String
        Public Property DataSourceId As String
        Public Property DataSourceName As String
        Public Property Name As String
        Public Property SourceNote As String
        Public Property SourceOrganization As String
        Public Property TopicId1 As Integer?
        Public Property TopicName1 As String
    End Class

    Public Class LendingTypeEntity
        Public Sub New()
        End Sub
        Public Property Code As String
        Public Property Name As String
    End Class

    Public Class RegionEntity
        Public Sub New()
        End Sub
        Public Property Code As String
        Public Property Name As String
    End Class

    Public Class TopicEntity
        Public Sub New()
        End Sub
        Public Property Id As Integer
        Public Property SourceNote As String
        Public Property Value As String
    End Class

End Namespace
