﻿Namespace Helpers.Zillow
    Public Class ChartsEntity
        Public Sub New()
        End Sub
        Public Property ChartUrl As String
        Public Property GraphsAndDataLink As String
        Public Property Height As Integer?
        Public Property UnitType As String
        Public Property Width As Integer?
        Public Property ZillowPropertyId As Integer
    End Class

    Public Class ComparablesEntity
        Public Sub New()
        End Sub
        Public Property City As String
        Public Property ComparablesLink As String
        Public Property GraphsAndDataLink As String
        Public Property HomeDetailsLink As String
        Public Property Latitude As Double?
        Public Property Longitude As Double?
        Public Property MapThisHomeLink As String
        Public Property MyEstimatorLink As String
        Public Property MyZestimatorLink As String
        Public Property PrincipalCity As String
        Public Property PrincipalComparablesLink As String
        Public Property PrincipalGraphsAndDataLink As String
        Public Property PrincipalHomeDetailsLink As String
        Public Property PrincipalLatitude As Double?
        Public Property PrincipalLongitude As Double?
        Public Property PrincipalMapThisHomeLink As String
        Public Property PrincipalMyEstimatorLink As String
        Public Property PrincipalMyZestimatorLink As String
        Public Property PrincipalState As String
        Public Property PrincipalStreet As String
        Public Property PrincipalZestimateAmount As Double?
        Public Property PrincipalZestimateAmountCurrency As String
        Public Property PrincipalZestimateLastUpdated As String
        Public Property PrincipalZestimateOneWeekChange As Double?
        Public Property PrincipalZestimateOneWeekChangeDeprecated As Boolean?
        Public Property PrincipalZestimatePercentile As Double?
        Public Property PrincipalZestimateValuationRangeHigh As Double?
        Public Property PrincipalZestimateValuationRangeHighCurrency As String
        Public Property PrincipalZestimateValuationRangeLow As Double?
        Public Property PrincipalZestimateValuationRangeLowCurrency As String
        Public Property PrincipalZestimateValueChange As Double?
        Public Property PrincipalZestimateValueChangeCurrency As String
        Public Property PrincipalZestimateValueChangeDuration As Integer?
        Public Property PrincipalZillowPropertyId As Integer
        Public Property PrincipalZipCode As String
        Public Property Score As Double?
        Public Property State As String
        Public Property Street As String
        Public Property ZestimateAmount As Double?
        Public Property ZestimateAmountCurrency As String
        Public Property ZestimateLastUpdated As String
        Public Property ZestimateOneWeekChange As Double?
        Public Property ZestimateOneWeekChangeDeprecated As Boolean?
        Public Property ZestimatePercentile As Double?
        Public Property ZestimateValuationRangeHigh As Double?
        Public Property ZestimateValuationRangeHighCurrency As String
        Public Property ZestimateValuationRangeLow As Double?
        Public Property ZestimateValuationRangeLowCurrency As String
        Public Property ZestimateValueChange As Double?
        Public Property ZestimateValueChangeCurrency As String
        Public Property ZestimateValueChangeDuration As Integer?
        Public Property ZillowPropertyId As Integer
        Public Property ZipCode As String
    End Class

    Public Class DeepSearchResultsEntity
        Public Sub New()

        End Sub
        Public Property Bathrooms As Double?
        Public Property Bedrooms As Double?
        Public Property City As String
        Public Property ComparablesLink As String
        Public Property FinishedSqFt As Double?
        Public Property FipsCounty As Integer?
        Public Property GraphsAndDataLink As String
        Public Property HomeDetailsLink As String
        Public Property LastSoldDate As String
        Public Property LastSoldPrice As Double?
        Public Property LastSoldPriceCurrency As String
        Public Property Latitude As Double?
        Public Property LocalRealEstateForSaleByOwnerLink As String
        Public Property LocalRealEstateForSaleLink As String
        Public Property LocalRealEstateName As String
        Public Property LocalRealEstateOverviewLink As String
        Public Property LocalRealEstateRegionId As Integer?
        Public Property LocalRealEstateType As String
        Public Property LocalRealEstateZindexOneYearChange As Double?
        Public Property LocalRealEstateZindexValue As Double?
        Public Property Longitude As Double?
        Public Property LotSizeSqFt As Double?
        Public Property MapThisHomeLink As String
        Public Property MyEstimatorLink As String
        Public Property MyZestimatorLink As String
        Public Property RegionCity As Integer?
        Public Property RegionForSaleByOwnerLink As String
        Public Property RegionForSaleLink As String
        Public Property RegionId As Integer?
        Public Property RegionName As Integer?
        Public Property RegionOverviewLink As String
        Public Property RegionZindexOneYearChange As Integer?
        Public Property RegionZindexValue As Integer?
        Public Property State As String
        Public Property Street As String
        Public Property TaxAssessment As Double?
        Public Property TaxAssessmentYear As Short?
        Public Property UseCode As String
        Public Property YearBuilt As Integer?
        Public Property ZestimateAmount As Double?
        Public Property ZestimateAmountCurrency As String
        Public Property ZestimateLastUpdated As String
        Public Property ZestimateOneWeekChange As Double?
        Public Property ZestimateOneWeekChangeDeprecated As Boolean?
        Public Property ZestimatePercentile As Double?
        Public Property ZestimateValuationRangeHigh As Double?
        Public Property ZestimateValuationRangeHighCurrency As String
        Public Property ZestimateValuationRangeLow As Double?
        Public Property ZestimateValuationRangeLowCurrency As String
        Public Property ZestimateValueChange As Double?
        Public Property ZestimateValueChangeCurrency As String
        Public Property ZestimateValueChangeDuration As Integer?
        Public Property ZillowPropertyId As Integer
        Public Property ZipCode As String
    End Class

    Public Class SearchResultsEntity
        Public Sub New()

        End Sub
        Public Property City As String
        Public Property ComparablesLink As String
        Public Property GraphsAndDataLink As String
        Public Property HomeDetailsLink As String
        Public Property Latitude As Double?
        Public Property LocalRealEstateForSaleByOwnerLink As String
        Public Property LocalRealEstateForSaleLink As String
        Public Property LocalRealEstateName As String
        Public Property LocalRealEstateOverviewLink As String
        Public Property LocalRealEstateRegionId As Integer?
        Public Property LocalRealEstateType As String
        Public Property LocalRealEstateZindexOneYearChange As Double?
        Public Property LocalRealEstateZindexValue As Double?
        Public Property Longitude As Double?
        Public Property MapThisHomeLink As String
        Public Property MyEstimatorLink As String
        Public Property MyZestimatorLink As String
        Public Property RegionCity As Integer?
        Public Property RegionForSaleByOwnerLink As String
        Public Property RegionForSaleLink As String
        Public Property RegionId As Integer?
        Public Property RegionName As Integer?
        Public Property RegionOverviewLink As String
        Public Property RegionZindexOneYearChange As Integer?
        Public Property RegionZindexValue As Integer?
        Public Property State As String
        Public Property Street As String
        Public Property ZestimateAmount As Double?
        Public Property ZestimateAmountCurrency As String
        Public Property ZestimateLastUpdated As String
        Public Property ZestimateOneWeekChange As Double?
        Public Property ZestimateOneWeekChangeDeprecated As Boolean?
        Public Property ZestimatePercentile As Double?
        Public Property ZestimateValuationRangeHigh As Double?
        Public Property ZestimateValuationRangeHighCurrency As String
        Public Property ZestimateValuationRangeLow As Double?
        Public Property ZestimateValuationRangeLowCurrency As String
        Public Property ZestimateValueChange As Double?
        Public Property ZestimateValueChangeCurrency As String
        Public Property ZestimateValueChangeDuration As Integer?
        Public Property ZillowPropertyId As Integer
        Public Property ZipCode As String
    End Class

    Public Class ZestimateEntity
        Public Sub New()
        End Sub

        Public Property City As String
        Public Property ComparablesLink As String
        Public Property GraphsAndDataLink As String
        Public Property HomeDetailsLink As String
        Public Property Latitude As Double?
        Public Property LocalRealEstateForSaleByOwnerLink As String
        Public Property LocalRealEstateForSaleLink As String
        Public Property LocalRealEstateName As String
        Public Property LocalRealEstateOverviewLink As String
        Public Property LocalRealEstateRegionId As Integer?
        Public Property LocalRealEstateType As String
        Public Property LocalRealEstateZindexOneYearChange As Double?
        Public Property LocalRealEstateZindexValue As Double?
        Public Property Longitude As Double?
        Public Property MapThisHomeLink As String
        Public Property MyEstimatorLink As String
        Public Property MyZestimatorLink As String
        Public Property RegionsCityId As Integer?
        Public Property RegionsCountyId As Integer?
        Public Property RegionsStateId As Integer?
        Public Property RegionsZipCodeId As Integer?
        Public Property State As String
        Public Property Street As String
        Public Property ZestimateAmount As Double?
        Public Property ZestimateAmountCurrency As String
        Public Property ZestimateLastUpdated As String
        Public Property ZestimateOneWeekChange As Double?
        Public Property ZestimateOneWeekChangeDeprecated As Boolean?
        Public Property ZestimatePercentile As Double?
        Public Property ZestimateValuationRangeHigh As Double?
        Public Property ZestimateValuationRangeHighCurrency As String
        Public Property ZestimateValuationRangeLow As Double?
        Public Property ZestimateValuationRangeLowCurrency As String
        Public Property ZestimateValueChange As Double?
        Public Property ZestimateValueChangeCurrency As String
        Public Property ZestimateValueChangeDuration As Integer?
        Public Property ZillowPropertyId As Integer
        Public Property ZipCode As String
    End Class
End Namespace